commit 0df51ea69ee1424466cc5203927f88c1a09b37c8
Author: Varun Nagaraju <varun.nagaraju@percona.com>
Date:   Mon Jul 29 23:54:46 2024 +0530

    PS-9301 Threads stuck waiting in connection control plugin
    
    https://perconadev.atlassian.net/browse/PS-9301
    
    Bug#35205358 mysql/mysql-server@3fc9c6a63a2
    
    Problem: Stage "conn_delay/Waiting in connection_control plugin" was not
    reset after delay introduced by connection control plugin which lead to
    incorrect monitoring intormation.
    
    Fix: Set the stage to the original one after the delay.
    
    Test: Check if the connection delay status last expected amount of time
    according to the performance schema.
    
    Change-Id: I810398a274fedb91b545c60875860a24ac953609

diff --git a/mysql-test/suite/connection_control/r/performance_schema.result b/mysql-test/suite/connection_control/r/performance_schema.result
new file mode 100644
index 00000000000..cbcfb03f721
--- /dev/null
+++ b/mysql-test/suite/connection_control/r/performance_schema.result
@@ -0,0 +1,22 @@
+# Setup
+INSTALL PLUGIN connection_control SONAME 'CONNECTION_CONTROL_LIB';
+INSTALL PLUGIN connection_control_failed_login_attempts SONAME 'CONNECTION_CONTROL_LIB';
+SET @@global.connection_control_failed_connections_threshold = 1;
+SET @@global.connection_control_min_connection_delay = 1230;
+SET @@global.connection_control_max_connection_delay = 1230;
+# Not delayed connection
+connect(localhost,u,,test,SOURCE_PORT,SOURCE_SOCKET);
+ERROR 28000: Access denied for user 'u'@'localhost' (using password: NO)
+# Delayed connection
+connect(localhost,u,,test,SOURCE_PORT,SOURCE_SOCKET);
+ERROR 28000: Access denied for user 'u'@'localhost' (using password: NO)
+# The stage event should be in the history, the timer wait must be slightly bigger
+# than configured connection delay, assume not more than 1/10 sec is good approximation,
+# so the below must be 0
+SELECT FLOOR((TIMER_WAIT/100000000000 - @@connection_control_min_connection_delay/100)) from performance_schema.events_stages_history_long WHERE EVENT_NAME LIKE 'stage/conn_delay/Waiting in connection_control plugin';
+FLOOR((TIMER_WAIT/100000000000 - @@connection_control_min_connection_delay/100))
+0
+# Cleanup
+# Uninstall connection_control plugin
+UNINSTALL PLUGIN connection_control;
+UNINSTALL PLUGIN connection_control_failed_login_attempts;
diff --git a/mysql-test/suite/connection_control/t/performance_schema-master.opt b/mysql-test/suite/connection_control/t/performance_schema-master.opt
new file mode 100644
index 00000000000..bc9d41e722d
--- /dev/null
+++ b/mysql-test/suite/connection_control/t/performance_schema-master.opt
@@ -0,0 +1,7 @@
+$CONNECTION_CONTROL_PLUGIN_OPT
+
+--performance-schema-instrument='stage/conn_delay/%=ON'
+--performance-schema-consumer-events-stages-current=ON
+--performance-schema-consumer-events-stages-history=ON
+--performance-schema-consumer-events-stages-history-long=ON
+--loose-debug='+d,delay_after_connection_delay'
diff --git a/mysql-test/suite/connection_control/t/performance_schema.test b/mysql-test/suite/connection_control/t/performance_schema.test
new file mode 100644
index 00000000000..41ab22e9525
--- /dev/null
+++ b/mysql-test/suite/connection_control/t/performance_schema.test
@@ -0,0 +1,40 @@
+# This test checks if when connection delay occurs the stage event
+# 'stage/conn_delay/Waiting in connection_control plugin'
+# lasts around @@global.connection_control_min_connection_delay,
+# so the user may get proper monitoring data.
+
+# The test will work only in debug mode
+--source include/have_debug.inc
+
+# Make sure that connection_control plugin can be loaded
+--source ../inc/have_connection_control_plugin.inc
+
+--echo # Setup
+--source ../inc/install_connection_control_plugin.inc
+
+# set connection_control variables
+SET @@global.connection_control_failed_connections_threshold = 1;
+SET @@global.connection_control_min_connection_delay = 1230;
+SET @@global.connection_control_max_connection_delay = 1230;
+
+# We don't need to use client side authentication plugin for this test.
+let $USE_AUTH_PLUGIN= 0;
+
+--echo # Not delayed connection
+--replace_result $MASTER_MYSOCK SOURCE_SOCKET $MASTER_MYPORT SOURCE_PORT
+--error ER_ACCESS_DENIED_ERROR
+connect(fail_con, localhost, u,,,,,);
+
+--echo # Delayed connection
+--replace_result $MASTER_MYSOCK SOURCE_SOCKET $MASTER_MYPORT SOURCE_PORT
+--error ER_ACCESS_DENIED_ERROR
+connect(fail_con, localhost, u,,,,,);
+
+--echo # The stage event should be in the history, the timer wait must be slightly bigger
+--echo # than configured connection delay, assume not more than 1/10 sec is good approximation,
+--echo # so the below must be 0
+SELECT FLOOR((TIMER_WAIT/100000000000 - @@connection_control_min_connection_delay/100)) from performance_schema.events_stages_history_long WHERE EVENT_NAME LIKE 'stage/conn_delay/Waiting in connection_control plugin';
+
+--echo # Cleanup
+--echo # Uninstall connection_control plugin
+--source ../inc/uninstall_connection_control_plugin.inc
diff --git a/plugin/connection_control/connection_delay.cc b/plugin/connection_control/connection_delay.cc
index cbc6421a53d..c1fc380f385 100644
--- a/plugin/connection_control/connection_delay.cc
+++ b/plugin/connection_control/connection_delay.cc
@@ -565,8 +565,7 @@ namespace connection_control
 
     /* Finish waiting and deregister wait condition */
     mysql_mutex_unlock(&connection_delay_mutex);
-    thd_exit_cond(thd, &stage_waiting_in_connection_control_plugin,
-                  __func__, __FILE__, __LINE__);
+    thd_exit_cond(thd, &old_stage, __func__, __FILE__, __LINE__);
 
     /* Cleanup */
     mysql_mutex_destroy(&connection_delay_mutex);
@@ -653,6 +652,12 @@ namespace connection_control
       rd_lock.lock();
     }
 
+    /*
+      Introduce a delay to check that connection delay status doesn't last
+      longer than configured
+    */
+    DBUG_EXECUTE_IF("delay_after_connection_delay", sleep(2););
+
     if (connection_event->status)
     {
       /*

